SystemOrganization addCategory: #'AmbientTalkST-Benchmarks'!

BenchmarkGameSuite subclass: #ATBenchmarkGameSuite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AmbientTalkST-Benchmarks'!

!ATBenchmarkGameSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/1/2012 17:39'!
benchATBinaryTrees
	| bench problemSize treeActor benchActor treeFactory result |
	problemSize := self problemSize
			ifNotNil: [ self problemSize ]
			ifNil:    [ BGBinaryTrees defaultProblemSize ].
	
	treeActor := ATActor new.
	benchActor := ATActor new.
	
	treeFactory := ATFarReference for: BGTreeNode in: treeActor. 
	
	bench := BGBinaryTrees new.
	bench binaryTreeFactory: treeFactory.
	
	result := benchActor evaluateAsync: [
		bench binarytrees: problemSize to: (TextStream with: String new).
	].
	
	^ result read.! !

!ATBenchmarkGameSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/2/2012 10:44'!
benchATFasta
	| randomnessActor bodies out bench |
	bench := BGFasta new.
	bench n: (self problemSize
						ifNotNil: [ self problemSize ]
						ifNil:    [ BGFasta defaultProblemSize ]).
	out := TextStream with: String new.
	bench out: out.
	
	randomnessActor := ATActor new.
	
	bench repeatStreamFact: (ATFarReference for: BGRepeatStream in: randomnessActor).
	bench oneHomoSapiensAlu.
	
	bench r: (ATFarReference for: (BGRandomNumber to: 1) in: randomnessActor).
	bench randomStreamFact: (ATFarReference for: BGRandomStream in: randomnessActor).
	
	bench twoIUBAmbiguityCodes.
	bench threeHomoSapiensFrequency.
	
	out flush.
	
	^ out contents.! !

!ATBenchmarkGameSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/1/2012 22:41'!
benchATNBody
	| problemSize bodiesActor bodies |
	problemSize := self problemSize
			ifNotNil: [ self problemSize ]
			ifNil:    [ BGNBody defaultProblemSize ].

	bodiesActor := ATActor new.
	
	bodies := ATFarReference for: BGNBodySystem new in: bodiesActor. 
	
	^ BGNBody nbody: problemSize with: bodies.
! !

Object subclass: #ATMicroSubject
	instanceVariableNames: 'cnt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AmbientTalkST-Benchmarks'!

!ATMicroSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/2/2012 14:32'!
counter
	^ cnt! !

!ATMicroSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/2/2012 14:31'!
incCounter
	cnt := cnt + 1.! !

!ATMicroSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/2/2012 14:31'!
initialize
	super initialize.
	cnt := 0.! !

!ATMicroSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/2/2012 14:41'!
process: z a: a b: b c: c d: d e: e f: f g: g h: h i: i
	cnt := cnt + 1.! !

SMarkLoops subclass: #ATBenchLoops
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AmbientTalkST-Benchmarks'!

!ATBenchLoops methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/31/2011 15:00'!
benchATFloatLoop
	| promise actor |
	
	actor := ATActor new.
	promise := actor evaluateAsync: [
		self benchFloatLoop.
		#done
	].

	[promise read = #done] assert.! !

!ATBenchLoops methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/31/2011 15:57'!
benchATIntLoop
	| promise actor |
	
	actor := ATActor new.
	promise := actor evaluateAsync: [
		self benchIntLoop.
		#done
	].

	[promise read = #done] assert.! !

SMarkLoops subclass: #ATMicroBenchmarks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AmbientTalkST-Benchmarks'!

!ATMicroBenchmarks methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/2/2012 14:51'!
benchLocalSend
	"In the omni version this one should be sensitive to field updates which will probably be measurable"
	| actor result |
	actor := ATActor new.
	
	result := actor evaluateAsync: [
		| o |
		o := ATMicroSubject new.
		1 to: 100000 do: [:i|
			o incCounter.
		].
		o counter
	].

	[result read = 100000] assert.! !

!ATMicroBenchmarks methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/2/2012 14:42'!
benchRemoteSend
	| actor cntActor cnt result |
	actor := ATActor new.
	cntActor := ATActor new.
	
	cnt := ATFarReference for: ATMicroSubject new in: cntActor.
	
	result := actor evaluateAsync: [
		1 to: 100000 do: [:i|
			cnt incCounter.
		].
		cnt counter
	].

	[result read = 100000] assert.! !

!ATMicroBenchmarks methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/2/2012 14:42'!
benchRemoteSendWithManyArguments
	| actor cntActor cnt result |
	actor := ATActor new.
	cntActor := ATActor new.
	
	cnt := ATFarReference for: ATMicroSubject new in: cntActor.
	
	result := actor evaluateAsync: [
		1 to: 100000 do: [:i|
			cnt process: i a: i b: i c: i d: i e: i f: i g: i h: i i: i.
		].
		cnt counter
	].

	[result read = 100000] assert.! !

TestCase subclass: #ATBenchmarkGameSuiteTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AmbientTalkST-Benchmarks'!

!ATBenchmarkGameSuiteTests methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/1/2012 22:52'!
testATBinaryTrees
	| bench |
	bench := ATBenchmarkGameSuite new.
	self assert: -1 equals: bench benchATBinaryTrees.! !

!ATBenchmarkGameSuiteTests methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/2/2012 10:46'!
testATFasta
	| atBench result |
	atBench := ATBenchmarkGameSuite new.
	result := atBench benchATFasta.
	
	self assert: result equals: BGFasta fasta.! !

!ATBenchmarkGameSuiteTests methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/1/2012 22:53'!
testATNBody
	| bench result |
	bench := ATBenchmarkGameSuite new.
	result := bench benchATNBody.
	
	self assert: (((result at: 2) asString) beginsWith: '-0.169087605')! !
